# -*- coding: UTF-8 -*-
from Components.Label import Label
from Components.ScrollLabel import ScrollLabel
from Components.ActionMap import  ActionMap
from Components.MenuList import MenuList
from Components.Pixmap import Pixmap
from enigma import  loadPic, eTimer, eConsoleAppContainer, eServiceReference
from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.VirtualKeyBoard import VirtualKeyBoard
import os,re, datetime, urllib,json
from Components.ServiceEventTracker import  InfoBarBase
from Screens.InfoBarGenerics import InfoBarSeek
from twisted.web.client import getPage

Version = "1.0.0"
Description_plug = "MyFreeMp3\xae"

def HTML(text):
	text = text.replace('&Auml;','Ae').replace('\u00c4','Ae').replace('&#196;','Ae').replace('&ouml;','oe').replace('\u00f6','oe')
	text = text.replace('&#246;','oe').replace('&ouml;','Oe').replace('\u00d6','Oe').replace('&#214;','Oe').replace('&uuml;','ue')
	text = text.replace('\u00fc','ue').replace('&#252;','ue').replace('&Uuml;','Ue').replace('\u00dc','Ue').replace('&#220;','Ue')	
	text = text.replace('&szlig;','ss').replace('\u00df','ss').replace('&#223;','ss').replace('&amp;','&').replace('&quot;','\"')
	text = text.replace('&gt;','\'').replace('&apos;',"'").replace('&acute;','\'').replace('&ndash;','-').replace('&bdquo;','"')
	text = text.replace('&rdquo;','"').replace('&ldquo;','"').replace('&lsquo;','\'').replace('&rsquo;','\'').replace('&#038;','&')
	text = text.replace('&#039;','\'').replace('&#160;',' ').replace('&#174;','').replace('&#225;','a').replace('&#233;','e').replace('&#39;','\'')
	text = text.replace('&#243;','o').replace('&#8211;',"-").replace('&#8216;',"'").replace('&#8217;',"'").replace('&#8220;',"'")
	text = text.replace('&#8221;','"').replace('&#8222;',',').replace('&#8230;','...')
	text = text.replace('&auml;','ae').replace('&Auml;','Ae').replace('&ouml;','oe').replace('&ouml;','Oe').replace('&uuml;','ue')
	text = text.replace('&Uuml;','Ue').replace('&szlig;','ss').replace('&amp;','&').replace('&quot;','\"').replace('&gt;','\'')
	text = text.replace('&#228;','ae').replace('&#246;','oe').replace('&#252;','ue').replace('&#223;','ss').replace('&#8230;','...')
	text = text.replace('&#8222;',',').replace('&#8220;',"'").replace('&#8216;',"'").replace('&#8217;',"'").replace('&#8211;',"-")
	text = text.replace('&#8230;','...').replace('&#8217;',"'").replace('&#128513;',":-)").replace('&#8221;','"')
	text = text.replace('\u00c4','Ae').replace('\u00e4;',"ae").replace('\u00d6',"Oe").replace('\u00f6','oe')
	text = text.replace('\u00dc','Ue').replace('\u00fc',"ue").replace('\u00df',"ss").replace('&amp',"&")
	text = text.replace('&ndash','').replace('&mdash',"").replace('&iexcl',"").replace('&iquest',"")  
	text = text.replace('&quot','"').replace('&ldquo',"").replace('&rdquo',"").replace('&lsquo',"")  
	text = text.replace('&rsquo','').replace('&laquo',"").replace('&raquo',"").replace('&nbsp'," ")    
	text = text.replace('<strong>','').replace('</strong>',"").replace('&auml;','ae').replace('\u00e4','ae').replace('&#228;','ae')
	text = text.replace('&auml;','').replace('\u00e4','').replace('&#228;','').replace('&Auml;','').replace('\u00c4','').replace('&#196;','')
	text = text.replace('&ouml;','').replace('\u00f6','').replace('&#246;','').replace('&ouml;','').replace('&Ouml;','').replace('\u00d6','')
	text = text.replace('&#214;','').replace('&uuml;','').replace('\u00fc','').replace('&#252;','').replace('&Uuml;','').replace('\u00dc','')
	text = text.replace('&#220;','').replace('&szlig;','').replace('\u00df','').replace('&#223;','').replace('&amp;','&').replace('&quot;','\"')
	text = text.replace('&gt;','>').replace('&apos;',"'").replace('&acute;','\'').replace('&ndash;','-').replace('&bdquo;','"').replace('&rdquo;','"')
	text = text.replace('&ldquo;','"').replace('&lsquo;','\'').replace('&rsquo;','\'').replace('&#034;','\'').replace('&#038;','&').replace('&#039;','\'')
	text = text.replace('&#160;',' ').replace('\u00a0',' ').replace('\u00b4','\'').replace('&#174;','').replace('&#225;','a').replace('&#233;','e')
	text = text.replace('&#243;','o').replace('&#8211;',"-").replace('\u2013',"-").replace('&#8216;',"'").replace('&#8217;',"'")
	text = text.replace('&#8220;',"'").replace('&#8221;','"').replace('&#8222;',',').replace('\u201e','\"').replace('\u201c','\"').replace('\u201d','\'')
	text = text.replace('\u2019s','\'').replace('\u00e0','').replace('\u00e7','').replace('\u00e9','').replace('&#xC4;','').replace('&#xD6;','')
	text = text.replace('&#xDC;','').replace('&#xE4;','').replace('&#xF6;','').replace('&#xFC;','').replace('&#xDF;','').replace('&#xE9;','')
	text = text.replace('&#xB7;','').replace("&#x27;","'").replace("&#x26;","&").replace("&#xFB;","").replace("&#xF8;","")
	text = text.replace("&#x21;","!").replace("&#x3f;","?").replace('&#8230;','...').replace('\u2026','...').replace('&hellip;','...')	
	return text
	
class MyFreeMp3About(Screen):
        
    def __init__(self, session):

        skin = "/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/About.xml"
        if os.path.exists(skin):  
            f = open(skin, "r")
            self.skin = f.read()
            f.close()	                                            
        Screen.__init__(self, session)            
        credit ="Release: "+Version+"\n"
        credit += "MyFreeMp3\nby m43c0 & mmark"                           
        credit2 ="Plugin for E2 MyFreeMp3. \n\n"		
        credit2 +="Plugin created by m43c0 collaboration with mmark"					
        self["key_info"] = Label(_(credit))	
        self["key_info2"] = Label(_(credit2))
        self["support"] = Label(" ")
        self.loop2 = eTimer()	
        self.loop2.stop()				
        self.loop2.callback.append(self.Close)	
        self.loop2.start(1000*10,1)	
        self["actions"] = ActionMap(["SetupActions"],
                {
           "ok": self.close, 
           "cancel": self.close				   
                }, -1)		
                    
    def Close(self):	
       self.loop2.stop()
       self.close()       
	   
class MyFreeMp3Screen(Screen,InfoBarBase, InfoBarSeek):

    def __init__(self, session, currentList,url):
        self.session = session
        skin = "/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/MyFreeMp3.xml"
        if os.path.exists(skin):
            f = open(skin, 'r')
            self.skin = f.read()
            f.close()
        Screen.__init__(self, session)
        InfoBarBase.__init__(self)
        InfoBarSeek.__init__(self)	
        self.Url	= url		
        self.jcurrentList = currentList	
        self.keyLocked = True		
        self.playing = False	
        self.currentList = "MainList"		
        self.MainList = []		
        self.EnterLocation	= ''
        self["MainList"] = MenuList(self.MainList)    
        self.PrimoPianoList = []		
        self["PrimoPianoList"] = MenuList(self.PrimoPianoList)  
        self['durata'] = Label("")	
        self['titolo'] = Label("")					
        self["onda"] = Label("")    	
        self["Key_Red"] = Label(_("Exit"))								
        self["Key_Yellow"] = Label("")			
        self["Key_Green"] = Label("")	   
        self["Key_Blu"] = Label("")
        self.lastservice = session.nav.getCurrentlyPlayingServiceReference()		
        self.MenuStart()
        if self.jcurrentList == 'MainList' or self.jcurrentList == 'PrimoPianoList':	
            self.keySwitchList()		
        self["myActionMap"] = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions"],
        {							
        "ok": self.go,		
        "cancel": self.cancel,						
        "red": self.cancel,					
        "left":self.MoveUp,
        "right":self.MoveDown,
        "nextBouquet" : self.keySwitchList,
        "prevBouquet" : self.keySwitchList,		
        "up":self.Up,
        "down":self.Down			
        }, -1)		
		
    def Info(self):
        try:	
            self['durata'].setText('Durata: '+self["MainList"].l.getCurrentSelection()[2])		
            self['titolo'].setText('Titolo: '+self["MainList"].l.getCurrentSelection()[0])
        except:
            self['durata'].setText('')		
            self['titolo'].setText('')
			
    def MenuStart(self):
        self.keyLocked = True
        self['onda'].setText('Attendere prego')		
        if self.jcurrentList == 'MainList':			
            getPage(self.Url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.Artists).addErrback(self.dataError)
        elif self.jcurrentList == 'PrimoPianoList':								
            getPage(self.Url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.Genres).addErrback(self.dataError)  
        else:			
            getPage(self.Url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.jMainList).addErrback(self.dataError)			
            self.SearchList()

    def SearchList(self): 
        self.PrimoPianoList = [(self.jcurrentList)]
        self['PrimoPianoList'].setList(self.PrimoPianoList)
        self['onda'].setText('')			
        self["PrimoPianoList"].selectionEnabled(0)
        self["MainList"].selectionEnabled(1)
        self.currentList = "MainList"	
        self.jcurrentList = 'search'
		
    def Artists(self,html): 
        self.PrimoPianoList = []
        try:	
            reg = re.compile('<li><a class="hash" href="(.+?)">(.+?)<\/a><\/li>',re.DOTALL).findall(html) 
            for link,name in reg:	
                self.PrimoPianoList.append((HTML(name).replace('mp3','').title(),'http://myfreemp3.eu'+link.replace(' ','%20')))	
        except:
            self.session.open(MessageBox, "Spiacente il contenuto di questa sezione e' momentaneamente non disponibile!\nRiprova piu tardi..", MessageBox.TYPE_ERROR, timeout=5)		
        self['PrimoPianoList'].setList(self.PrimoPianoList)
        self['onda'].setText('')			
        self.keyLocked = False				
                
    def Genres(self,html): 		
        self.PrimoPianoList = []
        try:	
            reg =  re.compile('<a class="hash artwork" href="(.+?)"><span><img src="(.+?)"></span>(.+?)</a></li>',re.DOTALL).findall(html) 
            for link,jpg,name in reg:	
                   self.PrimoPianoList.append((HTML(name).replace('mp3',''),'http://myfreemp3.eu'+link.replace(' ','%20').replace('artist','music')))	
        except:
            self.session.open(MessageBox, "Spiacente il contenuto di questa sezione e' momentaneamente non disponibile!\nRiprova piu tardi..", MessageBox.TYPE_ERROR, timeout=5)		
        self['PrimoPianoList'].setList(self.PrimoPianoList)
        self['onda'].setText('')		
        self.keyLocked = False	  

    def Menuprimari(self):
        self.keyLocked = True
        self['onda'].setText('Attendere prego')
        getPage(self["PrimoPianoList"].l.getCurrentSelection()[1], headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.jMainList).addErrback(self.dataError)		

    def jMainList(self,html): 		
        self.MainList = []
        try:	
            reg = re.compile('<div class="play"></div></div><a class="info" data-aid="(.+?)" data-current="0" data-duration=".+?">(.+?)</a><div class="add_panel"><div class="track_time">(.+?)</div>',re.DOTALL).findall(html) 	
            for id,name,jtimer in reg:	
                   self.MainList.append((HTML(name).replace('mp3',''),id,jtimer))	
        except:
            self.session.open(MessageBox, "Spiacente il contenuto di questa sezione e' momentaneamente non disponibile!\nRiprova piu tardi..", MessageBox.TYPE_ERROR, timeout=5)		
        self['MainList'].setList(self.MainList)
        self['onda'].setText('')		
        self.keyLocked = False	
        self["PrimoPianoList"].selectionEnabled(0)
        self["MainList"].selectionEnabled(1)
        self.Info()		
			
    def dataError(self,data): 
        pass
                          
    def doEofInternal(self, playing):
        self['MainList'].down()
        self.go()

    def lockShow(self):
        pass
                
    def unlockShow(self):
        pass		                             	
    
    def MoveUp(self): 
        if self.keyLocked:
            return	  	
        self[self.currentList].pageUp() 
        self.Info()	
		 
    def MoveDown(self):
        if self.keyLocked:
            return	  	
        self[self.currentList].pageDown()	
        self.Info()	
		 
    def Up(self):         
         if self.keyLocked:
            return	  	  
         self[self.currentList].instance.moveSelection(self[self.currentList].instance.moveUp)  	
         self.Info()		 
                 
    def Down(self):    
         if self.keyLocked:
            return	  	
         self[self.currentList].instance.moveSelection(self[self.currentList].instance.moveDown)     
         self.Info()	
		 
    def cancel(self): 		
        self.session.nav.stopService()
        self.session.nav.playService(self.lastservice)	
        self.playing = False	
        self.close()
 
    def keySwitchList(self):			
        if self.currentList == "MainList":
            if self.jcurrentList == 'search' :
		return
            self["MainList"].selectionEnabled(0)
            self["PrimoPianoList"].selectionEnabled(1)
            self.currentList = "PrimoPianoList"
            self['durata'].setText('')		
            self['titolo'].setText('')			
        elif self.currentList == "PrimoPianoList":
            if not self.MainList:
		return		
            self["PrimoPianoList"].selectionEnabled(0)
            self["MainList"].selectionEnabled(1)
            self.currentList = "MainList"	     
        else:
            pass
			
    def go(self):
        if self.currentList == "MainList":	
            if not self.MainList:
		return
            self.keyLocked = True
            self['onda'].setText('Attendere prego')
            getPage('http://unref.eu/%s'%self["MainList"].l.getCurrentSelection()[1], headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.play).addErrback(self.dataError)
        else:
            self.Menuprimari()
            self["PrimoPianoList"].selectionEnabled(0)
            self["MainList"].selectionEnabled(1)
            self.currentList = "MainList"	            
        
    def play(self,html):		
        try:	
            url = re.compile('window.open\("(.+?)"\);',re.DOTALL).findall(html)[0] 	
            self.session.nav.stopService()   				
            sref = eServiceReference(0x1001, 0, url)
            sref.setName(self["MainList"].l.getCurrentSelection()[0])				
            self.session.nav.playService(sref)
            self.playing = True				
        except:
            pass	
        self['onda'].setText('')		
        self.keyLocked = False	
		
    """		
    def Download(self):		
        Title = self["myMenu"].l.getCurrentSelection()[0]			
        Url = self["myMenu"].l.getCurrentSelection()[1]		
        DownloadCenter(self.session,Title,Url,'***','***','mp3')  	
    """
    
class MyFreeMp3Main(Screen):        
    def __init__(self, session):     
        self.session = session	
        skin = "/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/MyFreeMp3.xml"
        if os.path.exists(skin):  
            f = open(skin, "r")
            self.skin = f.read()
            f.close()						
        Screen.__init__(self, session)					
        self.MainList = []		
        self["MainList"] = MenuList(self.MainList)    
        self.PrimoPianoList = []		
        self["PrimoPianoList"] = MenuList(self.PrimoPianoList)  
        self.Url = None	
        self.currentList = "MainList"			
        self['durata'] = Label("")	
        self['titolo'] = Label("")					
        self["onda"] = Label("")    	
        self["Key_Red"] = Label(_("Exit"))								
        self["Key_Yellow"] = Label("")			
        self["Key_Green"] = Label("Search")	   
        self["Key_Blu"] = Label("")					
        self.playing = False
        self["PrimoPianoList"].selectionEnabled(0)
        self["MainList"].selectionEnabled(1)		
        self.MenuStart1()	 		
        self.MenuStartmain()	 		
        self.keySwitchList()		
        self["myActionMap"] = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions"],
        {							
        "ok": self.go,		
        "cancel": self.cancel,		
        "green": self.KeyBoard,			
        "red": self.cancel,					
        "left":self.MoveUp,
        "right":self.MoveDown,
        "nextBouquet" : self.keySwitchList,
        "prevBouquet" : self.keySwitchList,		
        "up":self.Up,
        "down":self.Down			
        }, -1)		
               
    def MenuStartmain(self):
        self.keyLocked = True
        self['onda'].setText('Attendere prego')
        getPage('http://myfreemp3.eu/genres/', headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.MenuStart2).addErrback(self.dataError)        
        
    def MenuStart1(self):
        self.MainList=[]
        self.MainList.append(('0..9','http://myfreemp3.eu/artists/'))
        self.MainList.append(('A' ,'http://myfreemp3.eu/artists/'))
        self.MainList.append(('B','http://myfreemp3.eu/artists/'))
        self.MainList.append(('C','http://myfreemp3.eu/artists/'))
        self.MainList.append(('D','http://myfreemp3.eu/artists/'))
        self.MainList.append(('E','http://myfreemp3.eu/artists/'))
        self.MainList.append(('F','http://myfreemp3.eu/artists/'))
        self.MainList.append(('G','http://myfreemp3.eu/artists/'))
        self.MainList.append(('H','http://myfreemp3.eu/artists/'))
        self.MainList.append(('I','http://myfreemp3.eu/artists/'))
        self.MainList.append(('J','http://myfreemp3.eu/artists/'))
        self.MainList.append(('K','http://myfreemp3.eu/artists/'))
        self.MainList.append(('L','http://myfreemp3.eu/artists/'))
        self.MainList.append(('M','http://myfreemp3.eu/artists/'))
        self.MainList.append(('N','http://myfreemp3.eu/artists/'))
        self.MainList.append(('O','http://myfreemp3.eu/artists/'))
        self.MainList.append(('P','http://myfreemp3.eu/artists/'))
        self.MainList.append(('Q','http://myfreemp3.eu/artists/'))
        self.MainList.append(('R','http://myfreemp3.eu/artists/'))
        self.MainList.append(('S','http://myfreemp3.eu/artists/'))
        self.MainList.append(('T','http://myfreemp3.eu/artists/'))
        self.MainList.append(('U','http://myfreemp3.eu/artists/'))
        self.MainList.append(('V','http://myfreemp3.eu/artists/'))
        self.MainList.append(('W','http://myfreemp3.eu/artists/'))
        self.MainList.append(('X','http://myfreemp3.eu/artists/'))
        self.MainList.append(('Y','http://myfreemp3.eu/artists/'))
        self.MainList.append(('Z','http://myfreemp3.eu/artists/'))		
        self["MainList"].l.setList(self.MainList)  	
        self['onda'].setText('')		
        self.keyLocked = False	
        self["PrimoPianoList"].selectionEnabled(0)
        self["MainList"].selectionEnabled(1)	  
                
    def MenuStart2(self,data):				
        self.PrimoPianoList  = []	
        reg = re.compile('<a class="hash" href="(.+?)">(.+?)<\/a><\/li>',re.DOTALL).findall(data) 
        for link,name in reg:
              self.PrimoPianoList.append((name,'http://myfreemp3.eu'+link))					
        self["PrimoPianoList"].l.setList(self.PrimoPianoList)  	
        self['onda'].setText('')
        self['Key_Blu'].setText('')		
        self.keyLocked = False	

    def KeyBoard(self):
         self.session.openWithCallback(lambda x : self.VirtualKeyBoardCallback(x),VirtualKeyBoard,title = (_("Title search:")), text = '')
                
    def VirtualKeyBoardCallback(self, callback = None):
        if callback is not None and len(callback):
            Search = callback.replace(' ','+').strip()
            url = 'http://myfreemp3.eu/music/%s'%Search		
            self.session.open(MyFreeMp3Screen,'Risultato ricerca : %s'%callback,url)	
			
    def dataError(self,data): 
            pass
                          
    def MoveUp(self): 
        if self.keyLocked:
            return	  	
        self[self.currentList].pageUp() 
                         
    def MoveDown(self):
        if self.keyLocked:
            return	  	
        self[self.currentList].pageDown()	
                         
    def Up(self):         
         if self.keyLocked:
            return	  	  
         self[self.currentList].instance.moveSelection(self[self.currentList].instance.moveUp)  			
                 
    def Down(self):    
         if self.keyLocked:
            return	  	
         self[self.currentList].instance.moveSelection(self[self.currentList].instance.moveDown)     			
                 
    def cancel(self): 	
        self.session.open(MyFreeMp3About)	
        self.close()	
				
    def keySwitchList(self):			
        if self.currentList == "MainList":
            self["MainList"].selectionEnabled(0)
            self["PrimoPianoList"].selectionEnabled(1)
            self.currentList = "PrimoPianoList"
        else:
            self["PrimoPianoList"].selectionEnabled(0)
            self["MainList"].selectionEnabled(1)
            self.currentList = "MainList"	                      
        
    def go(self): 
        if self.keyLocked:
            return		
        if self.currentList == 'MainList':			
            self.Url = 	'http://myfreemp3.eu/artists/%s/'%str(self["MainList"].l.getCurrentSelection()[0]).lower()	
        else:					
            self.Url = 	self["PrimoPianoList"].l.getCurrentSelection()[1]			
        self.session.open(MyFreeMp3Screen,self.currentList,self.Url)
                        
def Main(session, **kwargs):
        session.open(MyFreeMp3Main)

def Plugins(**kwargs):
        return PluginDescriptor(name = Description_plug, description = Description_plug+' '+Version, icon = 'mfmp3.png', where = [PluginDescriptor.WHERE_EXTENSIONSMENU,PluginDescriptor.WHERE_PLUGINMENU], fnc = Main)
                        
                         
